=== benchmarks/bytes_and_flops/CMakeLists.txt ===
kokkos_add_executable(
  bytes_and_flops
  SOURCES
  bench_double.cpp
  bench_float.cpp
  bench_int32_t.cpp
  bench_int64_t.cpp
  main.cpp
)
