=== benchmarks/gups/CMakeLists.txt ===
kokkos_add_executable(gups SOURCES gups.cpp)
