=== debian/changelog ===
kokkos (4.7.01-2) unstable; urgency=medium

  * Put header files into a subdir. (Closes: #1120018)
    Thanks Nils Schild for the testing and patch.
  * d/control: add to Science Team.

 -- Alex Myczko <tar@debian.org>  Wed, 05 Nov 2025 19:58:08 +0100

kokkos (4.7.01-1) unstable; urgency=medium

  * New upstream version.
  * Ack NMUs.
  * Bump standards version to 4.7.2.
  * d/copyright: bump year.
  * d/control: bump version from 4.5 to 4.7.

 -- Alex Myczko <tar@debian.org>  Tue, 28 Oct 2025 09:23:18 +0100

kokkos (4.5.01-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable tests on slow archs as they run into timeouts
  * Fix multi arch according to the MA hinter

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 27 Mar 2025 16:54:28 +0100
