=== debian/changelog ===
kokkos (5.0.0-2) experimental; urgency=medium

  * d/not-installed: use ${DEB_HOST_MULTIARCH}.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Dec 2025 19:21:16 +0000

kokkos (5.0.0-1) experimental; urgency=medium

  * New upstream version.
  * d/rules: skip tests.

 -- Alex Myczko <tar@debian.org>  Sat, 13 Dec 2025 13:52:21 +0000
