=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
  CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
  backends in development.
 
-Package: libkokkos4.7
+Package: libkokkos5.0
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -48,7 +48,7 @@
 Section: libdevel
 Depends:
  ${misc:Depends},
- libkokkos4.7 (= ${binary:Version}),
+ libkokkos5.0 (= ${binary:Version}),
 Description: C++ Performance Portability Programming
  This implements a programming model in C++ for writing performance
  portable applications targeting all major HPC platforms. For that purpose it
